

namespace VirtualGrid
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;

	using Syncfusion.Windows.Forms.Grid;
	using Syncfusion.Windows.Forms;
	using Syncfusion.Drawing;
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//turn off D&D support
			gridControl1.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);

			gridControl1.ResetVolatileData();
			gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
			gridControl1.QueryRowCount += new GridRowColCountEventHandler(GridQueryRowCount);
			//gridControl1.QueryCoveredRange += new GridQueryCellRangeEventHandler(GridQueryCoveredRange);
			gridControl1.QueryRowHeight += new GridRowColSizeEventHandler(GridQueryRowHeight);
			gridControl1.ColWidths[0] += 10;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		void GridQueryRowCount(object sender, GridRowColCountEventArgs e) 
		{
			e.Count = 30000;
			e.Handled = true;
		}

		void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e) 
		{
			if (e.RowIndex > 0)
			{
				if (e.ColIndex > 0)
				{
					if (e.ColIndex != 2)
						e.Style.CellValue = e.RowIndex.ToString() + "/" + e.ColIndex.ToString();

					if (e.RowIndex % 2 == 0)
					{
						e.Style.Interior = new BrushInfo(Color.FromArgb(0xED, 0xF0, 0xF7));
						e.Style.VerticalAlignment = GridVerticalAlignment.Bottom;
					}
					else
						e.Style.Interior = new BrushInfo(Color.FromArgb(0x91, 0xBB, 0xB8));

					if (e.ColIndex == 2)
					{
						if (e.RowIndex %2 == 0)
							e.Style.CellType = "PushButton";
						else
							e.Style.CellType = "DropDownGrid";
						e.Style.Description = "Click";
					}
					else
						e.Style.CellType = "Static";

					if (e.RowIndex % 4 == 0)
						e.Style.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, Color.Orange, GridBorderWeight.Medium);
				}
				e.Handled = true;
			}
		}


		void GridQueryRowHeight(object sender, GridRowColSizeEventArgs e) 
		{
			if (e.Index % 2 == 0)
			{
				e.Size = 25;
				e.Handled = true;
			}
		}

		void GridQueryCoveredRange(object sender, GridQueryCoveredRangeEventArgs e) 
		{
			if (e.RowIndex % 2 == 1 && e.ColIndex >= 1 && e.ColIndex <= 3)
			{
				e.Range = GridRangeInfo.Cells(e.RowIndex, 1, e.ColIndex, 3);
				e.Handled = true;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				gridControl1.QueryCellInfo -= new GridQueryCellInfoEventHandler(GridQueryCellInfo);
				gridControl1.QueryRowCount -= new GridRowColCountEventHandler(GridQueryRowCount);
				gridControl1.QueryCoveredRange -= new GridQueryCoveredRangeEventHandler(GridQueryCoveredRange);
				gridControl1.QueryRowHeight -= new GridRowColSizeEventHandler(GridQueryRowHeight);

				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridControl1.Bounds = new System.Drawing.Rectangle(24, 24, 504, 320);
			this.gridControl1.ColCount = 55;
			this.gridControl1.DefaultColWidth = 65;
			this.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Dotted;
			this.gridControl1.DefaultRowHeight = 17;
			this.gridControl1.Dock = System.Windows.Forms.DockStyle.None;
			this.gridControl1.HorizontalThumbTrack = true;
			this.gridControl1.Location = new System.Drawing.Point(24, 24);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 100;
			this.gridControl1.Size = new System.Drawing.Size(504, 320);
			this.gridControl1.TabIndex = 1;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.ThemesEnabled = true;
			this.gridControl1.VerticalThumbTrack = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form2());
		}
	}
}
